//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  2
#property indicator_color1   LimeGreen
#property indicator_color2   Orange
#property indicator_width1   2
#property indicator_width2   2
#property indicator_maximum  1
#property indicator_minimum -1

//
//
//
//
//

extern int Length = 34;
extern int Price  = PRICE_CLOSE;

double LRSBuffer[];
double LRSBufferU[];
double LRSBufferD[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,LRSBufferU); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"LR up");
   SetIndexBuffer(1,LRSBufferD); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"LR down");
   return(0);
}
int deinit() { return(0); }
int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      double slope  = LinearRegressionSlope(Length,i);
      LRSBufferU[i] = EMPTY_VALUE;
      LRSBufferD[i] = EMPTY_VALUE;
         if (slope > 0) LRSBufferU[i] =  1;
         if (slope < 0) LRSBufferD[i] = -1;
   }
   return(0);
}

//---------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------
//
//
//
//
//

int    lrs.period=EMPTY_VALUE;
double lrs.sumX;
double lrs.sumXSqr;
double lrs.divisor;
double LinearRegressionSlope(int len,int shift)
{
   double LinearRegSlope;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lrs.period != len)
   {
      lrs.period  = len;
      lrs.sumX    = lrs.period * (lrs.period-1) / 2;
      lrs.sumXSqr = lrs.period * (lrs.period-1) * (2 * lrs.period - 1) / 6;
      lrs.divisor = MathPow(lrs.sumX,2) - lrs.period * lrs.sumXSqr;
   }

   //
   //
   //
   //
   //

   for (int i=0; i<lrs.period; i++)
   {
      double price = iMA(NULL,0,1,0,MODE_EMA,Price,i+shift);
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lrs.divisor != 0 ) 
         	LinearRegSlope = (lrs.period * SumXY - lrs.sumX * SumY)/lrs.divisor;
   else     LinearRegSlope = 0; 
   return  (LinearRegSlope);
}